#| -*-Scheme-*-

Copyright (C) 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015,
    2016, 2017, 2018, 2019 Matthew Birkholz

This file is part of a planetarium plugin for MIT/GNU Scheme Pucked.

This plugin is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or (at your
option) any later version.

This plugin is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this plugin; if not, write to the Free Software Foundation,
Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

|#

;;;; Link a graphics type into the (planetarium) package.

(warn-errors? (lambda () (load-option 'gtk)))
(let ((planet (->environment '(planetarium)))
      (graphics (cond ((graphics-type-available? 'gtk)
		       (->environment '(planetarium gtk-graphics)))
		      ((graphics-type-available? 'x)
		       (->environment '(planetarium x-graphics)))
		      ((not (null? (enumerate-graphics-types)))
		       (->environment '(planetarium simple-graphics)))
		      (else #f))))
  (if graphics
      (for-each (lambda (name) (environment-link-name planet graphics name))
		'(make-suitable-graphics-device
		  draw-segment draw-circle draw-text
		  fill-polygon-available? fill-polygon
		  clear-graphics flush-graphics))
      (error "No graphics available.")))